/*
 * This Kotlin source file was generated by the Gradle 'init' task.
 */
package io.gitlab.mko_utilities.gradle_plugins.pebble

import io.gitlab.mko_utilities.gradle_plugins.pebble.PluginInfo.PLUGIN_NAME
import io.gitlab.mko_utilities.gradle_plugins.pebble.PluginInfo.PLUGIN_ID
import io.gitlab.mko_utilities.gradle_plugins.pebble.PluginInfo.PLUGIN_VERSION
import io.gitlab.mko_utilities.gradle_plugins.pebble.PluginInfo.PLUGIN_INFO_TASK_NAME
import io.gitlab.mko_utilities.gradle_plugins.pebble.tasks.DirectoryInstantiationTask
import io.gitlab.mko_utilities.gradle_plugins.pebble.tasks.FileInstantiationTask
import org.gradle.testfixtures.ProjectBuilder
import org.junit.jupiter.api.io.TempDir
import java.io.File
import kotlin.test.Test
import kotlin.test.assertTrue
import kotlin.test.assertFalse
import kotlin.test.assertNotNull

/**
 * Unit tests for the 'io.gitlab.mko_utilities.gradle_plugins.pebble' plugin.
 */
class PebblePluginTest {

    @Test fun `can apply plugin`() {
        // Create a test project and apply the plugin
        val project = ProjectBuilder.builder().build()
        project.plugins.apply(PLUGIN_ID)

        // Verify the result
        assertTrue(project.plugins.hasPlugin(PLUGIN_ID))
        assertNotNull(project.plugins.findPlugin(PLUGIN_ID))
        assertNotNull(project.plugins.getPlugin(PLUGIN_ID))
        assertNotNull(project.tasks.findByName(PLUGIN_INFO_TASK_NAME))
    }

    @Test fun `can register file instantiation task`() {
        // Create a test project and apply the plugin
        val project = ProjectBuilder.builder().build()
        project.plugins.apply(PLUGIN_ID)

        val taskName = "testInstantiationTask"
        project.tasks.register(taskName, FileInstantiationTask::class.java)

        // Verify the result
        assertFalse(project.tasks.isEmpty())
        assertNotNull(project.tasks.named(taskName).isPresent)
    }

    @Test fun `can register file tree instantiation task`() {
        // Create a test project and apply the plugin
        val project = ProjectBuilder.builder().build()
        project.plugins.apply(PLUGIN_ID)

        val taskName = "testInstantiationTask"
        project.tasks.register(taskName, DirectoryInstantiationTask::class.java)

        // Verify the result
        assertFalse(project.tasks.isEmpty())
        assertNotNull(project.tasks.named(taskName).isPresent)
    }

    @Test fun `can parse configuration DSL`() {
        val testProject =
            TestProject()
                .initSettingsFile()
                .initBuildFile {
                    writeText("""
                        plugins {
                            id("$PLUGIN_ID")
                        }
                        
                        pebble {
                            includedTemplateSources = files( layout.projectDirectory.dir("src/pebble/includes") )
                            dependencies {
                                register("dependencies-1") {
                                    // tmpProp = "tP1"
                                    from = project.fileTree(layout.projectDirectory.dir("src/templates/set-1"))
                                    to = layout.buildDirectory.dir("instances")
                                    instantiationOperators {
                                        register("instantiation-1") {
                                            // -- Using Groovy DSL:
                                            // parameters = [ testKey1: "TestValue1", testKey2: "TestValue2" ]
                                            // -- Using Kotlin DSL:
                                            parameters = mapOf(
                                              "testKey1" to "TestValue1",
                                              "testKey2" to "TestValue2"
                                            )
                                            // -- As lambda
                                            instanceNaming = { filePath, parameters -> filePath }
                                            // -- As Action
                                            // instanceNaming = Action { println("test: input") }
                                        }
                                    }
                                }
                                register("dependencies-2") {
                                    // tmpProp = "tP2"
                                    from = project.fileTree(layout.projectDirectory.dir("src/templates/set-2"))//.plus(project.fileTree(layout.projectDirectory.dir("src/templates/set-3")
                                    to = layout.buildDirectory.dir("instances")
                                }
                            }
                        }
                    """.trimIndent())
                }
        val test = testProject.run(PLUGIN_INFO_TASK_NAME)

        // Verify the result
        assertTrue(test.output.contains("This is plugin '$PLUGIN_NAME'"))
        assertTrue(test.output.contains("v$PLUGIN_VERSION"))
    }

}
